var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { Component, createElement } from "react";
import { from, throwError } from "rxjs";
import { distinctUntilChanged, map } from "rxjs/operators";
var Stream = (function (_super) {
    __extends(Stream, _super);
    function Stream(props, context, config) {
        var _this = _super.call(this, props, context) || this;
        _this._isMounted = false;
        var sourcePipe = (config ? config : props).pipe;
        var state$ = _this.configureSource(props, config).pipe(distinctUntilChanged(), sourcePipe || (function (x) { return x; }), map(function (state) { return (__assign({}, state, { children: state.children || state.render || props.children || props.render })); }));
        _this.subscription = state$.subscribe(function (state) {
            if (_this._isMounted) {
                _this.setState(function () { return state; });
            }
            else {
                _this.state = state;
            }
        });
        return _this;
    }
    Stream.prototype.configureSource = function (props, config) {
        var _a = (config
            ? config
            : props).source, source = _a === void 0 ? throwError("No source provided") : _a;
        return from(source);
    };
    Stream.prototype.componentDidMount = function () {
        this._isMounted = true;
    };
    Stream.prototype.render = function () {
        return this.state ? createElement(this.state.children, this.state) : null;
    };
    Stream.prototype.componentWillUnmount = function () {
        if (this.subscription)
            this.subscription.unsubscribe();
    };
    return Stream;
}(Component));
export { Stream };
export var stream = function (source, pipe, plans) { return function (props, context) {
    return new Stream(props, context, { source: source, pipe: pipe, plans: plans });
}; };
